 %%  paper-test2 SPRING n=1000
% EXACT PRECONDITIONER
% output: preproc.m with 2x2 block permutation and old Xini
% output2: preproc.m without 2x2 block permutation
% output3: preproc.m with 2x2 block permutation
clear

n=1000;
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3; % number of extracted eigenpairs (k_\pm >= l_\pm)
tol=1e-7;maxiter=1500;
M=speye(n);
e = ones(n,1);
% K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
% K=sparse(K);
% D=2*K;
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
D = spdiags([-10*e 30*e -10*e], -1:1, n, n); % definiteness interval is around ( -9.4818, -0.5278)
% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M D];%2n x 2n pencil

%% initial guess
I=speye(2*n);
II=speye(n);

%% 0. TEST:  mu0 (Alg.1)
mu0=-5;
T0=A-mu0*B;

fprintf('\n Test0: Algorithm 1 (one preconditioner) with T = inv(A-(%f)*B).\n',mu0);
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
tic
[D0, X, iter0,h0] = indef_lobpcg(A, B, T0, [], Xini, k_pos, k_neg, tol, maxiter);
t0=toc;
err0=norm(A*X-B*X*diag(D0));
save('output-paper-test3/outputSpringEXACT1000.mat','h0');
save('output-paper-test3/outputSpringEXACT1000.mat','D0','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter0','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t0','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','err0','-append');

fprintf('\n Test0: Algorithm 1 (one preconditioner) with  T = inv(A-(%f)*B). \n',mu0);
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=4;k_neg=4;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
tic
[D04, X, iter04,h04] = indef_lobpcg(A, B, T0, [], Xini, k_pos, k_neg, tol, maxiter);
t04=toc;
err04=norm(A*X-B*X*diag(D04));
save('output-paper-test3/outputSpringEXACT1000.mat','h04','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D04','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter04','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t04','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','err04','-append');

fprintf('\n Test0: Algorithm 1 (one preconditioner) with  T = inv(A-(%f)*B). \n',mu0);
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=5;k_neg=5;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
tic
[D05, X, iter05,h05] = indef_lobpcg(A, B, T0, [], Xini, k_pos, k_neg, tol, maxiter);
t05=toc;
err05=norm(A*X-B*X*diag(D05));
save('output-paper-test3/outputSpringEXACT1000.mat','h05','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D05','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter05','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t05','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','err05','-append');
%% 1. TEST: mu1p and mu1n
mu1p=-0.53;
mu1n=-9.2;
T1p=A-mu1p*B;
T1n=A-mu1n*B;

l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3; %
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test1: Algorithm 2 (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',mu1p,mu1n);
tic
[D1, X, iter1,h1] = indef_lobpcg(A, B, T1p, T1n, Xini, k_pos, k_neg, tol, maxiter);
t1=toc;
err1=norm(A*X-B*X*diag(D1));
save('output-paper-test3/outputSpringEXACT1000.mat','err1','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h1','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D1','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter1','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t1','-append');

l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=4;k_neg=4; %
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test1: Algorithm 2 (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',mu1p,mu1n);
tic
[D14, X, iter14,h14] = indef_lobpcg(A, B, T1p, T1n,  Xini, k_pos, k_neg, tol, maxiter);
t14=toc;
err14=norm(A*X-B*X*diag(D14));
save('output-paper-test3/outputSpringEXACT1000.mat','err14','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h14','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D14','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter14','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t14','-append');

l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=5;k_neg=5; %
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test1: Algorithm 2 (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',mu1p,mu1n);
tic
[D15, X, iter15,h15] = indef_lobpcg(A, B,  T1p, T1n,  Xini, k_pos, k_neg, tol, maxiter);
t15=toc;
err15=norm(A*X-B*X*diag(D15));
save('output-paper-test3/outputSpringEXACT1000.mat','err15','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h15','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D15','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter15','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t15','-append');

%% 2. TEST: mu2p and mu2n
mu2p=-0.55;
mu2n=-9;
T2p=A-mu2p*B;
T2n=A-mu2n*B;

k_pos=3;k_neg=3;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ = inv(A-(%f)*B), T_-=inv(A-(%f)*B).\n',mu2p,mu2n);
tic
[D2, X, iter2,h2] = indef_lobpcg(A, B, T2p, T2n, Xini, k_pos, k_neg, tol, maxiter);
t2=toc;
err2=norm(A*X-B*X*diag(D2));
save('output-paper-test3/outputSpringEXACT1000.mat','err2','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h2','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D2','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter2','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t2','-append');

k_pos=4;k_neg=4;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ = inv(A-(%f)*B), T_-=inv(A-(%f)*B).\n',mu2p,mu2n);
tic
[D24, X, iter24,h24] = indef_lobpcg(A, B,T2p, T2n, Xini, k_pos, k_neg, tol, maxiter);
t24=toc;
err24=norm(A*X-B*X*diag(D24));
save('output-paper-test3/outputSpringEXACT1000.mat','err24','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h24','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D24','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter24','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t24','-append');

k_pos=5;k_neg=5;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ = inv(A-(%f)*B), T_-=inv(A-(%f)*B).\n',mu2p,mu2n);
tic
[D25, X, iter25,h25] = indef_lobpcg(A, B,T2p, T2n, Xini, k_pos, k_neg, tol, maxiter);
t25=toc;
err25=norm(A*X-B*X*diag(D25));
save('output-paper-test3/outputSpringEXACT1000.mat','err25','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h25','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D25','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter25','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t25','-append');


%% 3. TEST: mu3p and mu3n
mu3p=-0.528;
mu3n=-9.47;
T3p=A-mu3p*B;
T3n=A-mu3n*B;

k_pos=5;k_neg=3;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ = inv(A-(%f)*B), T_-=inv(A-(%f)*B).\n',mu3p,mu3n);
tic
[D3, X, iter3,h3] = indef_lobpcg(A, B, T3p, T3n, Xini, k_pos, k_neg, tol, maxiter);
t3=toc;
err3=norm(A*X-B*X*diag(D3));
save('output-paper-test3/outputSpringEXACT1000.mat','err3','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h3','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D3','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter3','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t3','-append');
k_pos=4;k_neg=4;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ = inv(A-(%f)*B), T_-=inv(A-(%f)*B).\n',mu3p,mu3n);
tic
[D34, X, iter34,h34] = indef_lobpcg(A, B,T3p, T3n, Xini, k_pos, k_neg, tol, maxiter);
t34=toc;
err34=norm(A*X-B*X*diag(D34));
save('output-paper-test3/outputSpringEXACT1000.mat','err34','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h34','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D34','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter34','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t34','-append');

k_pos=5;k_neg=5;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ = inv(A-(%f)*B), T_-=inv(A-(%f)*B).\n',mu3p,mu3n);
tic
[D35, X, iter35,h35] = indef_lobpcg(A, B,T3p, T3n, Xini, k_pos, k_neg, tol, maxiter);
t35=toc;
err35=norm(A*X-B*X*diag(D35));
save('output-paper-test3/outputSpringEXACT1000.mat','err35','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h35','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D35','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter35','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t35','-append');


%% 4.TEST indefinite preconditioners

mu4p=-0.51;
mu4n=-20;
T4p=A-mu4p*B;
T4n=A-mu4n*B;

k_pos=3;k_neg=3;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ = inv(A-(%f)*B), T_-=inv(A-(%f)*B).\n',mu4p,mu4n);
tic
[D4, X, iter4,h4] = indef_lobpcg(A, B, T4p, T4n, Xini, k_pos, k_neg, tol, maxiter);
t4=toc;
err4=norm(A*X-B*X*diag(D4));
save('output-paper-test3/outputSpringEXACT1000.mat','err4','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h4','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D4','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter4','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t4','-append');
k_pos=4;k_neg=4;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ = inv(A-(%f)*B), T_-=inv(A-(%f)*B).\n',mu4p,mu4n);
tic
[D44, X, iter44,h44] = indef_lobpcg(A, B,T4p, T4n, Xini, k_pos, k_neg, tol, maxiter);
t44=toc;
err44=norm(A*X-B*X*diag(D44));
save('output-paper-test3/outputSpringEXACT1000.mat','err44','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h44','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D44','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter44','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t44','-append');

k_pos=5;k_neg=5;
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test2: Algorithm 2 (two preconditioners) with T_+ = inv(A-(%f)*B), T_-=inv(A-(%f)*B).\n',mu4p,mu4n);
tic
[D45, X, iter45,h45] = indef_lobpcg(A, B,T4p, T4n, Xini, k_pos, k_neg, tol, maxiter);
t45=toc;
err45=norm(A*X-B*X*diag(D45));
save('output-paper-test3/outputSpringEXACT1000.mat','err45','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','h45','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','D45','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','iter45','-append');
save('output-paper-test3/outputSpringEXACT1000.mat','t45','-append');
