function [X, AX, BX, d, m] = MGS2inv(X, AX, BX, A, B, k)

if nargin < 6,
    k = 0;
end

[n, m] = size(X);
R = zeros(m, m);
d = zeros(m, 1);
k = 0;

[X, AX, BX] = preprocinv(X, AX, BX, A, B, k);

i = 0;
while i < m,
    i = i + 1;
    reorth = 0;
    L = norm(X(:, i));
    if L == 0,
        fprintf('(1) rank deficient at column %d\n',i);
        X(:, i) = [];
        AX(:, i) = [];
        BX(:, i) = [];
        d(i) = [];
        i = i - 1;
        m = m - 1;
        continue;
    end
    X(:, i) = X(:, i) / L;
    u = X(:, i);
    AX(:, i) = AX(:, i) / L;
    BX(:, i) = BX(:, i) / L;
    for j = 1 : i - 1
        R(j, i) = X(:, j)' * BX(:, i) * d(j);
        X(:, i) = X(:, i) - R(j, i) * X(:, j);
        AX(:, i) = AX(:, i) - R(j, i) * AX(:, j);
        BX(:, i) = BX(:, i) - R(j, i) * BX(:, j);
    end
    R(i, i) = X(:, i)' * BX(:, i);
    d(i) = sign(R(i, i));
    if d(i) == 0
        fprintf('(2) rank deficient at column %d\n',i);
%         if i < m,
%             X(:, [i m]) = X(:, [m i]);
%             AX(:, [i m]) = AX(:, [m i]);
%             BX(:, [i m]) = BX(:, [m i]);
%             i = i - 1;
%             continue;
%         else,
            X(:, i) = [];
            AX(:, i) = [];
            BX(:, i) = [];
            d(i) = [];
            i = i - 1;
            m = m - 1;
            continue;
%         end
%         fprintf('i=%d\n', i)
%         error('R(i, i) = 0.');
%         return;
    end
    R(i, i) = sqrt(abs(R(i, i)));
    X(:, i) = X(:, i) / R(i, i);
    AX(:, i) = AX(:, i) / R(i, i);
    BX(:, i) = BX(:, i) / R(i, i);

    u1 = X(:, i) / norm(X(:, i));
    while u' * u1 < 0.95 && reorth < 5,
        reorth = reorth + 1;
        u = u1;
        for j = 1 : i - 1
            R(j, i) = X(:, j)' * BX(:, i) * d(j);
            X(:, i) = X(:, i) - R(j, i) * X(:, j);
            AX(:, i) = AX(:, i) - R(j, i) * AX(:, j);
            BX(:, i) = BX(:, i) - R(j, i) * BX(:, j);
        end
        R(i, i) = X(:, i)' * BX(:, i);
        d(i) = sign(R(i, i));
        if d(i) == 0
        fprintf('(3) rank deficient at column %d\n',i);
%             if i < m,
%                 X(:, [i m]) = X(:, [m i]);
%                 AX(:, [i m]) = AX(:, [m i]);
%                 BX(:, [i m]) = BX(:, [m i]);
%                 i = i - 1;
%                 continue;
%             else,
                X(:, i) = [];
                AX(:, i) = [];
                BX(:, i) = [];
                d(i) = [];
                i = i - 1;
                m = m - 1;
                continue;
%             end
%             fprintf('i=%d\n', i)
%             error('R(i, i) = 0.');
%             return;
        end
        R(i, i) = sqrt(abs(R(i, i)));
        X(:, i) = X(:, i) / R(i, i);
        AX(:, i) = A \ X(:, i);
        BX(:, i) = B \ X(:, i);
%        AX(:, i) = AX(:, i) / R(i, i);
%        BX(:, i) = BX(:, i) / R(i, i);
        u1 = X(:, i) / norm(X(:, i));
    end
end
% disp('MGS')
% t = norm(X'*BX-diag(diag(X'*BX)))
% if t > 1e-9,
%     disp(X'*BX)
% end
return
