function [DI,X,iter0,h0,e2,DG,VG,iter0G,h0G,e2G]=plat1919_example_comparison(msch,kpos,kneg,la0,tol1,tol2,A)

% 25.2.2019.: comparison indef_m_scheme_brzo_inverse vs indef_m_scheme_brzoG
 %%  test_plat362 ex. 6.4
fprintf ('Testing arbitrary spectral gap using 2 versions  of the indef_m_scheme applied to the Atlantic Ocean model:\n') ;
% tol1=1e-8;tol2=1e-8
% msch=10;kpos=6;kneg=6;la0=0.024;tol1=1e-7;tol2=1e-7;
tol=1e-7;maxiter=100;

  load plat1919.mtx
  A=mmread('plat1919.mtx');
n=size(A,2);
la0=0.0121;
I=speye(n);
A1=A-la0*I;B=I;
%%

tic
 [G,J,err1,err2,err3]=ind_dec(A1);
td=toc;
fprintf('\n cond(A1)=%2.5e, cond(G)=%2.5e\n', condest(A1),condest(G))


%disp(['Dekompozicija: norme gresaka = ',num2str(err)])
[err1,err2,err3]
%%
%kpos=1;kneg=1;
k=kpos+kneg;  % number of wanted eigenpairs
%msch=3;
XiniJ=InitialGuess(diag(J),kpos,kneg);
%% indef_m_scheme_brzo_inverse
Xini=G*XiniJ;
Xini=full(Xini);
fprintf('\n Test: indef_m_scheme_brzo_inverse (I, invA1) for lambda0 = %f.\n',la0);
tic
 [D, X, iter0,h0] = indef_m_scheme_brzo_inverse(I, A1, I, [], Xini, kpos, kneg, tol1, maxiter,msch);
t0=toc; 
    DI=diag(D+la0); 
    err=norm(A*X-B*X*DI);
    if k==2
       disp('Norma greske reziduala po komponentama:')
       [norm(A*X(:,1)-B*X(:,1)*DI(1,1)),norm(A*X(:,2)-B*X(:,2)*DI(2,2))]
    end
  %    disp('Greska normiranja')
     e2=X'*X;
 %% indef_m_scheme_brzoG
XiniJ=full(XiniJ);
fprintf('\n Test: indef_m_scheme_brzoG for lambda0 = %f.\n',la0);
  tic
       [D0G, XG, iter0G,h0G] = indef_m_scheme_brzoG(G, J, G, [], XiniJ, kpos, kneg, tol2, maxiter,msch);
  t0G=toc;
  
     greskaAlgG=norm(G'*(G*XG)-J*XG*diag(D0G));
     VG=G*(XG/sqrt(abs(diag(D0G))));
     DG=diag(D0G+la0);   
     errG=norm(A*VG-B*VG*DG);
     if k==2
        disp('Norma greske reziduala po komponentama:')
        [norm(A*VG(:,1)-B*VG(:,1)*DG(1,1)),norm(A*VG(:,2)-B*VG(:,2)*DG(2,2))]
     end
     %[err0,err0p]
     % disp('Greska normiranja')
     e2G=VG'*VG;  
%% results
     for i=1:k
        [norm(X(:,i)), norm(XG(:,1)), norm(VG(:,1))]  
     end
     %
fprintf('\n cond(A1)=%2.5e, cond(G)=%2.5e\n', condest(A1),condest(G))
fprintf('\n Results: msch= %d, kpos= %d,kneg= %d.\n',msch,kpos,kneg)
fprintf('\n Test: Broj iteracija inverz= %d vs (G,J)= %d.\n',iter0,iter0G)
fprintf('\n Test: Greske inverz= %2.5e vs (G,J)=%2.5e vs nakon (G,J)= %2.5e.\n',err,greskaAlgG,errG)
fprintf('\n Test: Vrijeme inverz= %f vs (G,J)= %f.\n',t0,t0G)
norm(diag(DI)-diag(DG))
%      
%   e2
%   e2G
%   [norm(X(:,1)),norm(X(:,2))]
%      [norm(XG(:,1)),norm(XG(:,2))]
%      [norm(VG(:,1)),norm(VG(:,2))]

%  subplot(2,1,1);
% plot(h0.eigen_neg,'x-')
% hold on
% plot(h0G.eigen_neg,'rs-.')
% subplot(2,1,2);
% plot(h0.eigen_pos,'x-')
% hold on
% plot(h0G.eigen_pos,'rs-.')
        

%% drugi kriterij
%% indef_m_scheme_brzo_inverse
disp('drugi kriterij')
fprintf('\n Test: indef_m_scheme_brzo_inverse (I, invA1) for lambda0 = %f.\n',la0);
tic
 [D, X, iter02,h0] = indef_m_scheme_brzo_inverse_2crit(I, A1, I, [], Xini, kpos, kneg, tol1, maxiter,msch);
t02=toc; 
    DI=diag(D+la0); 
    err2=norm(A*X-B*X*DI);
    if k==2
       disp('Norma greske reziduala po komponentama:')
       [norm(A*X(:,1)-B*X(:,1)*DI(1,1)),norm(A*X(:,2)-B*X(:,2)*DI(2,2))]
    end
  %    disp('Greska normiranja')
     e2=X'*X;
 %% indef_m_scheme_brzoG

fprintf('\n Test: indef_m_scheme_brzoG for lambda0 = %f.\n',la0);
  tic
       [D0G, XG, iter0G2,h0G] = indef_m_scheme_brzoG_2crit(G, J, G, [], XiniJ, kpos, kneg, tol2, maxiter,msch);
  t0G2=toc;
     greskaAlgG2=norm(G'*(G*XG)-J*XG*diag(D0G));
     VG=G*(XG/sqrt(abs(diag(D0G))));
     DG=diag(D0G+la0);   
     errG2=norm(A*VG-B*VG*DG);
     if k==2
        disp('Norma greske reziduala po komponentama:')
        [norm(A*VG(:,1)-B*VG(:,1)*DG(1,1)),norm(A*VG(:,2)-B*VG(:,2)*DG(2,2))]
     end
     %err0p=norm(A*VG-B*VG*diag(DG));
     %[err0,err0p]
     % disp('Greska normiranja')
     e2G=VG'*VG;  

%% results
     for i=1:k
        [norm(X(:,i)), norm(XG(:,1)), norm(VG(:,1))]  
     end
     %
     disp('results for the first criterion:')
fprintf('\n cond(A1)=%2.5e, cond(G)=%2.5e\n', condest(A1),condest(G))
fprintf('\n Results: msch= %d, kpos= %d,kneg= %d.\n',msch,kpos,kneg)
fprintf('\n Test: Broj iteracija inverz= %d vs (G,J)= %d.\n',iter0,iter0G)
fprintf('\n Test: Greske inverz= %2.5e vs (G,J)=%2.5e vs nakon (G,J)= %2.5e.\n',err,greskaAlgG,errG)
fprintf('\n Test: Vrijeme inverz= %f vs (G,J)= %f.\n',t0,t0G)
norm(diag(DI)-diag(DG))
disp('results for the second criterion:')
    fprintf('\n Test: Broj iteracija inverz= %d vs (G,J)= %d.\n',iter02,iter0G2)
    fprintf('\n Test: Greske inverz= %2.5e vs (G,J)=%2.5e vs nakon (G,J)= %2.5e.\n',err2,greskaAlgG2,errG2)
    fprintf('\n Test: Vrijeme inverz= %f vs (G,J)= %f.\n',t02,t0G2)
%       e2
%       e1G
      norm(diag(DI)-diag(DG))
