function [DI,X,iter0,h0,DG,VG,iter0G,h0G]=proba(n,msch,kpos,kneg)

% 25.2.2019.: comparison indef_m_scheme_brzo_inverse vs indef_m_scheme_brzoG
 %%  test_spring
fprintf ('Testing arbitrary spectral gap using 2 versions  of the indef_m_scheme applied to the spring problem:\n') ;
n=1000;
D = sparse(1:n,1:n,-2*ones(1,n),n,n);
E = sparse(2:n,1:n-1,ones(1,n-1),n,n);
A = E+D+E';
% E=eig(A);
% ev=E(6:7)
tol=1e-7;maxiter=100;
 n=size(A,2);
la0=-2.5;
la0=-1.2
I=speye(n);
A1=A-la0*I;B=I;
%%
disp('cond(A1):')
condest(A1)
tic
 [G,J,err1,err2,err3]=ind_dec(A1);
td=toc;
%spy(G)
%disp(['Dekompozicija: norme gresaka = ',num2str(err)])
[err1,err2,err3]
%%
kpos=1;kneg=1;
k=kpos+kneg;  % number of wanted eigenpairs
msch=3;
XiniJ=InitialGuess(diag(J),kpos,kneg);
%% indef_m_scheme_brzo_inverse
Xini=G*XiniJ;
Xini=full(Xini);
fprintf('\n Test: indef_m_scheme_brzo_inverse (I, invA1) for lambda0 = %f.\n',la0);
tic
 [D, X, iter0,h0] = indef_m_scheme_brzo_inverse(I, A1, I, [], Xini, kpos, kneg, tol, maxiter,msch);
t0=toc; 
    DI=diag(D+la0); 
    err=norm(A*X-B*X*DI);
    if k==2
       disp('Norma greke reziduala po komponentama:')
       [norm(A*X(:,1)-B*X(:,1)*DI(1,1)),norm(A*X(:,2)-B*X(:,2)*DI(2,2))]
    end
  %    disp('Greska normiranja')
     e2=X'*X;
 %% indef_m_scheme_brzoG
XiniJ=full(XiniJ);
fprintf('\n Test: indef_m_scheme_brzoG for lambda0 = %f.\n',la0);
  tic
       [D0G, XG, iter0G,h0G] = indef_m_scheme_brzoG(G, J, G, [], XiniJ, kpos, kneg, tol, maxiter,msch);
  t0G=toc;
     greskaAlgG=norm(G'*(G*XG)-J*XG*diag(D0G))
     VG=G*(XG/sqrt(abs(diag(D0G))));
     DG=diag(D0G+la0);   
     errG=norm(A*VG-B*VG*DG);
     if k==2
        disp('Norma greke reziduala po komponentama:')
        [norm(A*VG(:,1)-B*VG(:,1)*DG(1,1)),norm(A*VG(:,2)-B*VG(:,2)*DG(2,2))]
     end
     %err0p=norm(A*VG-B*VG*diag(DG));
     %[err0,err0p]
     % disp('Greska normiranja')
     e1G=VG'*VG;  
%% results
 disp('results:')
    fprintf('\n Test: Broj iteracija inverz= %d vs (G,J)= %d.\n',iter0,iter0G)
    fprintf('\n Test: Greske inverz= %2.5e vs (G,J)= %2.5e.\n',err,errG)
    fprintf('\n Test: Vrijeme inverz= %f vs (G,J)= %f.\n',t0,t0G)
%     [iter0,iter0G]
%       [err,errG]
%       [t0,t0G]
%       e2
%       e1G
      norm(diag(DI)-diag(DG))
  
%       [ev,diag(DI),diag(DG)]
%       norm(diag(DI)-ev)
%        norm(diag(DG)-ev)
     
% %      
% %      subplot(2,1,1);
% % plot(h0.eigen_neg,'x-')
% % hold on
% % plot(h0G.eigen_neg,'rs-.')
% % subplot(2,1,2);
% % plot(h0.eigen_pos,'x-')
% % hold on
% % plot(h0G.eigen_pos,'rs-.')
% %     
%% drugi kriterij
%% indef_m_scheme_brzo_inverse

fprintf('\n Test: indef_m_scheme_brzo_inverse (I, invA1) for lambda0 = %f.\n',la0);
tic
 [D, X, iter0,h0] = indef_m_scheme_brzo_inverse_2crit(I, A1, I, [], Xini, kpos, kneg, tol1, maxiter,msch);
t0=toc; 
    DI=diag(D+la0); 
    err=norm(A*X-B*X*DI);
    if k==2
       disp('Norma greke reziduala po komponentama:')
       [norm(A*X(:,1)-B*X(:,1)*DI(1,1)),norm(A*X(:,2)-B*X(:,2)*DI(2,2))]
    end
  %    disp('Greska normiranja')
     e2=X'*X;
 %% indef_m_scheme_brzoG

fprintf('\n Test: indef_m_scheme_brzoG for lambda0 = %f.\n',la0);
  tic
       [D0G, XG, iter0G,h0G] = indef_m_scheme_brzoG_2crit(G, J, G, [], XiniJ, kpos, kneg, tol2, maxiter,msch);
  t0G=toc;
     greskaAlgG=norm(G'*(G*XG)-J*XG*diag(D0G));
     VG=G*(XG/sqrt(abs(diag(D0G))));
     DG=diag(D0G+la0);   
     errG=norm(A*VG-B*VG*DG);
     if k==2
        disp('Norma greke reziduala po komponentama:')
        [norm(A*VG(:,1)-B*VG(:,1)*DG(1,1)),norm(A*VG(:,2)-B*VG(:,2)*DG(2,2))]
     end
     %err0p=norm(A*VG-B*VG*diag(DG));
     %[err0,err0p]
     % disp('Greska normiranja')
     e2G=VG'*VG;  
%% results
disp('results:')
    fprintf('\n Test: Broj iteracija inverz= %d vs (G,J)= %d.\n',iter0,iter0G)
    fprintf('\n Test: Greske inverz= %2.5e vs (G,J)=%2.5e vs nakon (G,J)= %2.5e.\n',err,greskaAlgG,errG)
    fprintf('\n Test: Vrijeme inverz= %f vs (G,J)= %f.\n',t0,t0G)
%       e2
%       e1G
      norm(diag(DI)-diag(DG))
     
  e2
  e2G
     %% treci kriterij
%% indef_m_scheme_brzo_inverse

fprintf('\n Test: indef_m_scheme_brzo_inverse (I, invA1) for lambda0 = %f.\n',la0);
tic
 [D, X, iter0,h0] = indef_m_scheme_brzo_inverse_1crit(I, A1, I, [], Xini, kpos, kneg, tol1, maxiter,msch);
t0=toc; 
    DI=diag(D+la0); 
    err=norm(A*X-B*X*DI);
    if k==2
       disp('Norma greke reziduala po komponentama:')
       [norm(A*X(:,1)-B*X(:,1)*DI(1,1)),norm(A*X(:,2)-B*X(:,2)*DI(2,2))]
    end
  %    disp('Greska normiranja')
     e2=X'*X;
 %% indef_m_scheme_brzoG

fprintf('\n Test: indef_m_scheme_brzoG for lambda0 = %f.\n',la0);
  tic
       [D0G, XG, iter0G,h0G] = indef_m_scheme_brzoG_1crit(G, J, G, [], XiniJ, kpos, kneg, tol2, maxiter,msch);
  t0G=toc;
     greskaAlgG=norm(G'*(G*XG)-J*XG*diag(D0G));
     VG=G*(XG/sqrt(abs(diag(D0G))));
     DG=diag(D0G+la0);   
     errG=norm(A*VG-B*VG*DG);
     if k==2
        disp('Norma greke reziduala po komponentama:')
        [norm(A*VG(:,1)-B*VG(:,1)*DG(1,1)),norm(A*VG(:,2)-B*VG(:,2)*DG(2,2))]
     end
     %err0p=norm(A*VG-B*VG*diag(DG));
     %[err0,err0p]
     % disp('Greska normiranja')
     e2G=VG'*VG;  
%% results
disp('results:')
    fprintf('\n Test: Broj iteracija inverz= %d vs (G,J)= %d.\n',iter0,iter0G)
    fprintf('\n Test: Greske inverz= %2.5e vs (G,J)=%2.5e vs nakon (G,J)= %2.5e.\n',err,greskaAlgG,errG)
    fprintf('\n Test: Vrijeme inverz= %f vs (G,J)= %f.\n',t0,t0G)
%       e2
%       e1G
      norm(diag(DI)-diag(DG))
     
  e2
  e2G
     %% cetvrti kriterij
  %% indef_m_scheme_brzo_inverse

fprintf('\n Test: indef_m_scheme_brzo_inverse (I, invA1) for lambda0 = %f.\n',la0);
tic
 [D, X, iter0,h0] = indef_m_scheme_brzo_inverse_21crit(I, A1, I, [], Xini, kpos, kneg, tol1, maxiter,msch);
t0=toc; 
    DI=diag(D+la0); 
    err=norm(A*X-B*X*DI);
    if k==2
       disp('Norma greke reziduala po komponentama:')
       [norm(A*X(:,1)-B*X(:,1)*DI(1,1)),norm(A*X(:,2)-B*X(:,2)*DI(2,2))]
    end
  %    disp('Greska normiranja')
     e2=X'*X;
 %% indef_m_scheme_brzoG

fprintf('\n Test: indef_m_scheme_brzoG for lambda0 = %f.\n',la0);
  tic
       [D0G, XG, iter0G,h0G] = indef_m_scheme_brzoG_21crit(G, J, G, [], XiniJ, kpos, kneg, tol2, maxiter,msch);
  t0G=toc;
     greskaAlgG=norm(G'*(G*XG)-J*XG*diag(D0G));
     VG=G*(XG/sqrt(abs(diag(D0G))));
     DG=diag(D0G+la0);   
     errG=norm(A*VG-B*VG*DG);
     if k==2
        disp('Norma greke reziduala po komponentama:')
        [norm(A*VG(:,1)-B*VG(:,1)*DG(1,1)),norm(A*VG(:,2)-B*VG(:,2)*DG(2,2))]
     end
     %err0p=norm(A*VG-B*VG*diag(DG));
     %[err0,err0p]
     % disp('Greska normiranja')
     e2G=VG'*VG;  
%% results
disp('results:')
    fprintf('\n Test: Broj iteracija inverz= %d vs (G,J)= %d.\n',iter0,iter0G)
    fprintf('\n Test: Greske inverz= %2.5e vs (G,J)=%2.5e vs nakon (G,J)= %2.5e.\n',err,greskaAlgG,errG)
    fprintf('\n Test: Vrijeme inverz= %f vs (G,J)= %f.\n',t0,t0G)
%       e2
%       e1G
      norm(diag(DI)-diag(DG))
     
  e2
  e2G
