function [X, AX, BX] = preprocLH(X, AX, BX, L,H, B, k)
% preprocLH(X, AX, BX, L,H, B, k) differs from preprocG(X, AX, BX, G, B, k)
% in A = H'*((L')\(L\H))

if k > 0,
    T = (BX(:, 1:k)'*X(:, 1:k)) \ BX(:, 1:k)'*X(:, k+1:end);
    X(:, k+1:end) = X(:, k+1:end)-X(:, 1:k)*T;
    AX(:, k+1:end) = AX(:, k+1:end)-AX(:, 1:k)*T;
    BX(:, k+1:end) = BX(:, k+1:end)-BX(:, 1:k)*T;
end
Bp = X(:, k+1:end)'*BX(:, k+1:end);
if norm(Bp-Bp') > 1e-12 * norm(Bp),
    AX = H'*((L')\(L\(H*X)));
    BX = B*X;
    Bp = X(:, k+1:end)'*BX(:, k+1:end);
end
Bp = (Bp+Bp')/2;
if 1,
    [U, D, P] = ldl(Bp, 'upper');
    X(:, k+1:end) = X(:, k+1:end) * P / U;
    AX(:, k+1:end) = AX(:, k+1:end) * P / U;
    BX(:, k+1:end) = BX(:, k+1:end) * P / U;
    for i = 1:size(Bp,2)-1,
        if D(i, i+1) ~= 0,
            [QQ, DD] = eig(D(i:i+1, i:i+1));
            if abs(DD(1, 1)) < abs(DD(2, 2)),
                QQ = QQ(:, [2, 1]);
            end
            X(:, k+i:k+i+1) = X(:, k+i:k+i+1) * QQ;
            AX(:, k+i:k+i+1) = AX(:, k+i:k+i+1) * QQ;
            BX(:, k+i:k+i+1) = BX(:, k+i:k+i+1) * QQ;
        end
    end
else
    [U, D] = eig(Bp);
    [D0, ind] = sort(-abs(diag(D)));
    X(:, k+1:end) = X(:, k+1:end) * U(:, ind);
    AX(:, k+1:end) = AX(:, k+1:end) * U(:, ind);
    BX(:, k+1:end) = BX(:, k+1:end) * U(:, ind);
end
%t = norm(X'*BX-diag(diag(X'*BX)))
%if t > 1e-12,
%    disp(X'*BX)
%end