randn('state',0);
% 21.2.2019.: comparison indef_m_scheme_brzo_inverse 
% kako kondicija od B2 utjece na rezultate?
 %%  test_spring
fprintf ('Testing arbitrary spectral gap using indef_m_scheme_brzo_inverse applied to the spring problem:\n') ;

n=1000; tol=1e-7;maxiter=100;
kpos=1;kneg=1;k=kpos+kneg;  % number of wanted eigenpairs

M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278)
%% exact evs:  
 f_neg=zeros(1,n);f_pos=zeros(1,n);
    for k=1:n,
        c=cos(k*pi/(n+1));
        f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
        f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
        f_neg(n-k+1)=min(f([2*k-1 2*k]));
        f_pos(k)=max(f([2*k-1 2*k]));
    end
    ev_pos=f_pos(1:kpos);               % kpos wanted B-positive evs
    ev_neg=f_neg(n+1-kneg:n);           % kneg wanted B-negative evs

%% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M C];%2n x 2n pencil
V0=perfect_shuffling(n); %perfect shuffling
A1=V0'*A*V0; B1=V0'*B*V0;
%%
lad=-5; % definitizing shift
A2=A1-lad*B1; % this one is positive definite
L=chol(A2,'lower');
%% a) B2
la0=-0.5086; % arbitrary number in (\lambda_min, \lambda_max)

B2=B1-(1/(la0-lad))*A2;
cB2=condest(B2);
tic
 [H,J,P,err]=dekompozicijaPetdijagonalne(B2);
td=toc;
%norm(H*J*H'-R)
disp(['Dekompozicija petdijagonalne: norma greske = ',num2str(err)]);
G=L\H;
T=G'*G;
XiniJ=InitialGuess(diag(J),kpos,kneg);

Xini=H*XiniJ;
Xini=full(Xini);
fprintf('\n Test: indef_m_scheme_brzo_inverse for lambda0 = %f., lambdad=%f.\n',la0,lad);

tic
 [D0d, X, iter0,h0] = indef_m_scheme_brzo_inverse(A2, B2, A2, [], Xini, kpos, kneg, tol, maxiter,5);
t0=toc; 
     V1=A2\X; % sv. vektori od (A1,B1)
     V=V0*V1; % sv. vektori od (A,B)
     d=1/(la0-lad); %broj
     D1=1./(D0d+d)+lad;
   %  disp('Norma greke reziduala:')
     err0=norm(A*V-B*V*diag(D1));
      disp('Norma greke reziduala po komponentama:')
     [norm(A*V(:,1)-B*V(:,1)*D1(1)),norm(A*V(:,2)-B*V(:,2)*D1(2))]
  %    disp('Greska normiranja')
     e2=V'*B*V;


%% B3
la0=-0.508595; % arbitrary number in (\lambda_min, \lambda_max)
B3=B1-(1/(la0-lad))*A2;
cB3=condest(B3);
% tic
%  [H3,J3,P,err]=dekompozicijaPetdijagonalne(B3);
% td3=toc;
% %norm(H*J*H'-R)
% disp(['Dekompozicija petdijagonalne: norma greske = ',num2str(err)]);
% 
% G3=L\H3;
% T3=G3'*G3;
%XiniJ=InitialGuess(diag(J3),kpos,kneg);
% Xini=H3*XiniJ;
% Xini=full(Xini);
fprintf('\n Test: indef_m_scheme_brzo_inverse for lambda0 = %f., lambdad=%f.\n',la0,lad);

tic
 [D03, X3, iter3,h3] = indef_m_scheme_brzo_inverse(A2, B3, A2, [], Xini, kpos, kneg, tol, maxiter,5);
t03=toc; 
     V13=A2\X3; % sv. vektori od (A1,B1)
     V3=V0*V13; % sv. vektori od (A,B)
     d3=1/(la0-lad); %broj
     D3=1./(D03+d3)+lad;
   %  disp('Norma greke reziduala:')
     err3=norm(A*V3-B*V3*diag(D3));
      disp('Norma greke reziduala po komponentama:')
     [norm(A*V3(:,1)-B*V3(:,1)*D3(1)),norm(A*V3(:,2)-B*V3(:,2)*D3(2))]
  %    disp('Greska normiranja')
     e3=V3'*B*V3;
%% B4
 la0=-0.50859533; % arbitrary number in (\lambda_min, \lambda_max)
la0=-0.508593310;
B4=B1-(1/(la0-lad))*A2;
cB4=condest(B4);
% tic
%  [H4,J4,P,err]=dekompozicijaPetdijagonalne(B4);
% td4=toc;
% %norm(H*J*H'-R)
% disp(['Dekompozicija petdijagonalne: norma greske = ',num2str(err)]);
% 
% G4=L\H4;
% T4=G4'*G4;
%XiniJ=InitialGuess(diag(J4),kpos,kneg);
% Xini=H4*XiniJ;
% Xini=full(Xini);
fprintf('\n Test: indef_m_scheme_brzo_inverse for lambda0 = %f., lambdad=%f.\n',la0,lad);

tic
 [D04, X4, iter4,h4] = indef_m_scheme_brzo_inverse(A2, B4, A2, [], Xini, kpos, kneg, tol, maxiter,5);
t04=toc; 
     V14=A2\X4; % sv. vektori od (A1,B1)
     V4=V0*V14; % sv. vektori od (A,B)
     d4=1/(la0-lad); %broj
     D4=1./(D04+d4)+lad;
   %  disp('Norma greke reziduala:')
     err4=norm(A*V4-B*V4*diag(D4));
      disp('Norma greke reziduala po komponentama:')
     [norm(A*V4(:,1)-B*V4(:,1)*D4(1)),norm(A*V4(:,2)-B*V4(:,2)*D4(2))]
  %    disp('Greska normiranja')
     e4=V4'*B*V4;

%% results
[cB2,cB3,cB4]
      [iter0,iter3,iter4]
      [t0,t03,t04]
      [err0,err3,err4]
      e2
      e3
      e4
      
