
randn('state',0);
 %%  test_spring
fprintf ('Testing arbitrary spectral gap using indef_LOBPCG applied to the spring problem:\n') ;

n=1000; kpos=5;kneg=5;k=kpos+kneg;msch=5;
tol=1e-7;maxiter=100;
M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278)

%% exact evs:  
 f_neg=zeros(1,n);f_pos=zeros(1,n);
    for k=1:n,
        c=cos(k*pi/(n+1));
        f([2*k-1 2*k])=roots([1, 30-20*c, 15-10*c]);
        f([2*k-1 2*k])=sort(f([2*k-1 2*k]));
        f_neg(n-k+1)=min(f([2*k-1 2*k]));
        f_pos(k)=max(f([2*k-1 2*k]));
    end
    ev_pos=f_pos(1:kpos);               % kpos wanted B-positive evs
    ev_neg=f_neg(n+1-kneg:n);           % kneg wanted B-negative evs
%     figure(1)
%     subplot(3,1,1)
%     plot(real(f),imag(f),'k.')
%     title('Sve svojstvene vrijednosti','FontSize',16);
%     axis([-60 10 -1 1])
%     hold all
%     subplot(3,1,2)
%     plot(f_neg,'k.')
%      title('B-negativne','FontSize',16);
%     subplot(3,1,3)
%     plot(f_pos,'k.')
%     title('B-pozitivne','FontSize',16);
   
    %% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M C];%2n x 2n pencil
V0=perfect_shuffling(n); %perfect shuffling
%%
lad=-5; % definitizing shift
la0=-0.5086; % arbitrary number in (\lambda_min, \lambda_max)

A1=V0'*A*V0; B1=V0'*B*V0;
A2=A1-lad*B1; % this one is positive definite
B2=B1-(1/(la0-lad))*A2;
condest(B2)
tic
[H,J,P,err]=dekompozicijaPetdijagonalne(B2);
td=toc;
%norm(H*J*H'-R)
disp(['Dekompozicija petdijagonalne: norma greske = ',num2str(err)]);
L=chol(A2,'lower');

G=L\H;
T=G'*G;
     Xini=InitialGuess(diag(J),kpos,kneg);
     Xini=full(Xini);
     % Xini'*J*Xini
L=sparse(L);
H=sparse(H);
% %  %% comparison
% %       tic
% %        [D0d, X, iter0,h0] = indef_m_scheme_brzo(T, J, T, [], Xini, kpos, kneg, tol, maxiter,msch);
% %       t0=toc;
% %       tic
% %        [D0d, X, iter0G,h0] = indef_m_scheme_brzoG(G, J, G, [], Xini, kpos, kneg, tol, maxiter,msch);
% %       t0G=toc;
% %         tic
% %        [D0d, X, iter0LH,h0] = indef_m_scheme_brzoLH(L,H, J, G, [], Xini, kpos, kneg, tol, maxiter,msch);
% %       t0LH=toc;
% %       [t0,t0G,t0LH]
% %       [iter0,iter0G,iter0LH]
 %% full comparison 
fprintf('\n Test0: indef_m_scheme_brzo (T,J) for lambda0 = %f., lambdad=%f.\n',la0,lad);
   tic
       [D0d, X, iter0,h0] = indef_m_scheme_brzo(T, J, T, [], Xini, kpos, kneg, tol, maxiter,msch);
   t0=toc;
     V1=L'\(G*(X/sqrt(abs(diag(D0d)))));
     d=1/(la0-lad); %broj
     format long e
     % disp('Svojstvene vrijednosti izracunate algoritmom')
     D1=1./(D0d+d)+lad;  
     V=V0*V1;
     err0=norm(A*V-B*V*diag(D1));
     if k==2
      disp('Norma greke reziduala po komponentama')
      [norm(A*V(:,1)-B*V(:,1)*D1(1)),norm(A*V(:,2)-B*V(:,2)*D1(2))]
     end
     % disp('Greska normiranja')
     e1=V'*(A-lad*B)*V;
     e2=V'*B*V;
fprintf('\n Test0: indef_m_scheme_brzoG (GH G,J) for lambda0 = %f., lambdad=%f.\n',la0,lad);
 
tic
       [D0dG, XG, iter0G,hG] = indef_m_scheme_brzoG(G, J, G, [], Xini, kpos, kneg, tol, maxiter,msch);
   t0G=toc;    
     V1G=L'\(G*(XG/sqrt(abs(diag(D0dG)))));
     dG=1/(la0-lad); %broj
     format long e
     % disp('Svojstvene vrijednosti izracunate algoritmom')
     D1G=1./(D0dG+dG)+lad;  
     VG=V0*V1G;
     err0G=norm(A*VG-B*VG*diag(D1G));
     if k==2
      disp('Norma greke reziduala po komponentama')
      [norm(A*VG(:,1)-B*VG(:,1)*D1G(1)),norm(A*VG(:,2)-B*VG(:,2)*D1G(2))]
     end
     % disp('Greska normiranja')
     e1G=VG'*(A-lad*B)*VG;
     e2G=VG'*B*VG;
  Xini=InitialGuess(diag(J),kpos+1,kneg+1);
     Xini=full(Xini);     
fprintf('\n Test0: indef_m_scheme_brzoLH ((invL G)H(invL G),J) for lambda0 = %f., lambdad=%f.\n',la0,lad);
   tic
       [D0dL, XL, iter0LH,h0L] = indef_m_scheme_brzoLH(L,H, J, G, [], Xini, kpos, kneg, tol, maxiter,msch);
   t0LH=toc;
     V1L=L'\(L\(H*(X/sqrt(abs(diag(D0d))))));
     dL=1/(la0-lad); %broj
     format long e
     % disp('Svojstvene vrijednosti izracunate algoritmom')
     D1L=1./(D0dL+dL)+lad;  
     VL=V0*V1L;
     err0L=norm(A*VL-B*VL*diag(D1L));
     if k==2
      disp('Norma greke reziduala po komponentama')
      [norm(A*VL(:,1)-B*VL(:,1)*D1L(1)),norm(A*VL(:,2)-B*VL(:,2)*D1L(2))]
     end
     % disp('Greska normiranja')
     e1L=VL'*(A-lad*B)*VL;
     e2L=VL'*B*VL; 
 % results from comparison     
      [iter0,iter0G,iter0LH]
      [err0,err0G,err0L]
      [t0,t0G,t0LH]
      
     
      
      
      %%  %% using decomposition with G
%        tic
%        [D0d, X, iter0G,h0] = indef_m_scheme_brzoG(G, J, G, [], Xini, kpos, kneg, tol, maxiter,3);
%       t0=toc;
%      D0d
%      greskaAlg=norm(T*X-J*X*diag(D0d))
%      [norm(T*X(:,1)-J*X(:,1)*D0d(1)),norm(T*X(:,2)-J*X(:,2)*D0d(2))]
%      V1=L'\(L\(H*(X/sqrt(abs(diag(D0d))))));
%     % V1=L'\(G*(X/sqrt(abs(diag(D0d)))));
%      d=1/(la0-lad); %broj
%      format long e
%       disp('Svojstvene vrijednosti izracunate algoritmom')
%      D1=1./(D0d+d)+lad
%       disp('Svojstvene vrijednosti izracunate formulom')
%      f_pos(500:503)
%      V=V0*V1;
%      %Vp=V0*V1p;
%      err0=norm(A*V-B*V*diag(D1))
%       disp('Norma greke reziduala po komponentama')
%      [norm(A*V(:,1)-B*V(:,1)*D1(1)),norm(A*V(:,2)-B*V(:,2)*D1(2))]
%      %err0p=norm(A*Vp-B*Vp*diag(D1));
%      %[err0,err0p]
%       disp('Greska normiranja')
%      e1=V'*(A-lad*B)*V
%      %e2=V'*B*V
%       disp('Vrijeme indefinitne dekompozicije, algortima')
%      vrijeme=[td,t0]
     

%%
lad=-5; % definitizing shift
la0=-30; % arbitrary number in (\lambda_min, \lambda_max)
fprintf('\n Test0: Algorithm 1 (one preconditioner) for lambda0 = %f., lambdad=%f.\n',la0,lad);
A1=V0'*A*V0; B1=V0'*B*V0;
A2=A1-lad*B1; % this one is positive definite
R=B1-(1/(la0-lad))*A2;
cond(R)
tic
[H,J,P,err]=dekompozicijaPetdijagonalne(R);
td=toc;
disp(['Dekompozicija petdijagonalne: norma greske = ',num2str(err)]);
L=chol(A2,'lower');
l_pos=1;l_neg=1; % number of wanted eigenpairs
k_pos=1;k_neg=1;
tol=1e-7;maxiter=500;
G=L\H;
T=G'*G;
     Xini=InitialGuess(diag(J),kpos,kneg);
     Xini=full(Xini);
     % Xini'*J*Xini
     %% comparison
%       tic
%        [D0d, X, iter0,h0] = indef_m_scheme_brzo(T, J, T, [], Xini, kpos, kneg, tol, maxiter,3);
%       t0=toc;
%       tic
%        [D0d, X, iter0G,h0] = indef_m_scheme_brzoG(G, J, G, [], Xini, kpos, kneg, tol, maxiter,3);
%       t0G=toc;
%         tic
%        [D0d, X, iter0LH,h0] = indef_m_scheme_brzoLH(L,H, J, G, [], Xini, kpos, kneg, tol, maxiter,3);
%       t0LH=toc;
%       [t0,t0G,t0LH]
%       [iter0,iter0G,iter0LH]
      
%% using decomposition with G
%       tic
%        [D0d, X, iter0G,h0] = indef_m_scheme_brzoG(G, J, G, [], Xini, kpos, kneg, tol, maxiter,3);
%       t0G=toc;

     D0d
     greskaAlg=norm(T*X-J*X*diag(D0d))
     %V1p=L'\(L\(H*X*sqrt(abs(diag(D0d)))));
     V1=L'\(L\(H*(X/sqrt(abs(diag(D0d))))));
     V1=L'\(G*(X/sqrt(abs(diag(D0d)))));
     d=1/(la0-lad); %broj
     format long e
     disp('Svojstvene vrijednosti izracunate algoritmom')
     D1=1./(D0d+d)+lad
      disp('Svojstvene vrijednosti izracunate formulom')
     f_neg(491:494)
     V=V0*V1;
     %Vp=V0*V1p;
     err0=norm(A*V-B*V*diag(D1))
     [norm(A*V(:,1)-B*V(:,1)*D1(1)),norm(A*V(:,2)-B*V(:,2)*D1(2))]
     
     %err0p=norm(A*Vp-B*Vp*diag(D1));
     %[err0,err0p]
      disp('Greska normiranja')
     e1=V'*(A-lad*B)*V
     %e2=Vp'*(A-lad*B)*Vp   
      disp('Vrijeme indefinitne dekompozicije, algortima')
     vrijeme=[td,t0]
     


