function []=comparison_indef_m_scheme_spring3(n)
% TEST 3: lambda_1^\pm, lambda_2^\pm,lambda_2^\pm

l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3; % number of extracted eigenpairs (k_\pm >= l_\pm)
tol=1e-7;maxiter=500;
M=speye(n);
e = ones(n,1);
% K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
% K=sparse(K);
% D=2*K;
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
D = spdiags([-10*e 30*e -10*e], -1:1, n, n); % definiteness interval is around ( -9.4818, -0.5278)
% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M D];%2n x 2n pencil

%% initial guess
%I=speye(2*n);
II=speye(n);
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
X=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
%% definitizing shifts and preconditioners
mup=-0.528;
mun=-9.47;
Tp=A-mup*B;
Tn=A-mun*B;
% % CC = ichol(A-mup*B);
% % CholeskyIC0=@(r) CC\((CC')\r);
% % T=CholeskyIC0;

flag = [1 1 1 1 1 1];

if flag(1),
fprintf('\n Test1: Indefinite (2)-scheme  with T_+ = inv(A-(%f)*B) and T_=inv(A-(%f)*B).\n',mup,mun);
tic
  [D2, X2, iter2,h2] = indef_m_scheme(A, B, Tp, Tn, X, l_pos, l_neg, tol, maxiter,2);
t2=toc;
D2'
fprintf('#(iterations) = ');
[h2.step_neg(:,end:-1:1),h2.step_pos]
end 

if flag(2),
fprintf('\n Test1: Indefinite (3)-scheme  with T_+ = inv(A-(%f)*B) and T_=inv(A-(%f)*B).\n',mup,mun);
tic
  [D3, X3, iter3,h3] = indef_m_scheme(A, B, Tp, Tn, X, l_pos, l_neg, tol, maxiter,3);
t3=toc;
D3'
fprintf('#(iterations) = ');
[h3.step_neg(:,end:-1:1),h3.step_pos]
end 
if flag(3),
fprintf('\n Test1: Indefinite (4)-scheme  with T_+ = inv(A-(%f)*B) and T_=inv(A-(%f)*B).\n',mup,mun);
tic
  [D4, X4, iter4,h4] = indef_m_scheme(A, B, Tp, Tn, X, l_pos, l_neg, tol, maxiter,4);
t4=toc;
D4'
fprintf('#(iterations) = ');
[h4.step_neg(:,end:-1:1),h4.step_pos]
end 
if flag(4),
fprintf('\n Test1: Indefinite (5)-scheme  with T_+ = inv(A-(%f)*B) and T_=inv(A-(%f)*B).\n',mup,mun);
tic
  [D5, X5, iter5,h5] = indef_m_scheme(A, B, Tp, Tn, X, l_pos, l_neg, tol, maxiter,5);
t5=toc;
D5'
fprintf('#(iterations) = ');
[h5.step_neg(:,end:-1:1),h5.step_pos]
end 
if flag(5),
fprintf('\n Test1: Indefinite (6)-scheme  with T_+ = inv(A-(%f)*B) and T_=inv(A-(%f)*B).\n',mup,mun);
tic
  [D6, X6, iter6,h6] = indef_m_scheme(A, B, Tp, Tn, X, l_pos, l_neg, tol, maxiter,6);
t6=toc;
D6'
fprintf('#(iterations) = ');
[h6.step_neg(:,end:-1:1),h6.step_pos]
end 
if flag(6),
fprintf('\n Test1: Indefinite scheme with whole history with T_+ = inv(A-(%f)*B) and T_=inv(A-(%f)*B).\n',mup,mun);
tic
  [Dw, Xw, iterw,hw] = indef_m_scheme(A, B, Tp, Tn, X, l_pos, l_neg, tol, maxiter,'whole');
tw=toc;
Dw'
fprintf('#(iterations) = ');
[hw.step_neg(:,end:-1:1),hw.step_pos]
end

%[def_neg,def_pos]=def_interval_spring(n);

if min(flag) == 1,
fprintf('Number of total iterations: m=2')
[h2.step_neg(:,end:-1:1),h2.step_pos]
fprintf('Number of total iterations: m=3')
[h3.step_neg(:,end:-1:1),h3.step_pos]
fprintf('Number of total iterations: m=4')
[h4.step_neg(:,end:-1:1),h4.step_pos]
fprintf('Number of total iterations: m=5')
[h5.step_neg(:,end:-1:1),h5.step_pos]
fprintf('Number of total iterations: m=6')
[h6.step_neg(:,end:-1:1),h6.step_pos]
fprintf('Number of total iterations: m=whole')
[hw.step_neg(:,end:-1:1),hw.step_pos]
end
