
clear

n=800;
l_pos=1;l_neg=1; % number of wanted eigenpairs
k_pos=3;k_neg=3; % number of extracted eigenpairs (k_\pm >= l_\pm)
tol=1e-7;maxiter=15;
M=speye(n);
e = ones(n,1);
% K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
% K=sparse(K);
% D=2*K;
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
D = spdiags([-10*e 30*e -10*e], -1:1, n, n); % definiteness interval is around ( -9.4818, -0.5278)
% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M D];%2n x 2n pencil

%% initial guess
I=speye(2*n);
II=speye(n);

%% 0. TEST:  mu0 (Alg.1)
mu0=-5;
T0=A-mu0*B;

%% 1. TEST: mu1p and mu1n
mu1p=-0.528;
%mu1p=-5;
mu1n=-9.47;
T1p=A-mu1p*B;
T1n=A-mu1n*B;
%T1n=[];

l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3; %
%Xini=full([[M,II;-II,II]*I(:,n+1:(n+k_neg)) I(:,1:k_pos)]);
Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
fprintf('\n Test1: Algorithm indef_lobpcg (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',mu1p,mu1n);
tic
[D1, X, iter1,h1] = indef_lobpcg(A, B, T1p, T1n, Xini, k_pos, k_neg, tol, maxiter);
t1=toc;
err1=norm(A*X-B*X*diag(D1));
fprintf('\n Test1: Algorithm indef_m_scheme_brzo (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',mu1p,mu1n);
tic
[D14,X,iter14,h14]=indef_m_scheme_brzo(A,B,T1p,T1n,Xini,k_pos,k_neg,tol,maxiter,3);
t14=toc;
err14=norm(A*X-B*X*diag(D14));
norm(h1.eigen_neg-h14.eigen_neg)
norm(h1.eigen_pos-h14.eigen_pos)



fprintf('\n Test1: Algorithm indef_m_scheme_sporo (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',mu1p,mu1n);
tic
[D15, X, iter15,h15] =  indef_m_scheme_sporo(A, B, T1p, T1n,  Xini, k_pos, k_neg, tol, maxiter,3);
t15=toc;
err15=norm(A*X-B*X*diag(D15));
norm(h1.eigen_neg-h15.eigen_neg)
norm(h1.eigen_pos-h15.eigen_pos)
[iter1-iter15,iter1-iter14]
[t1,t14,t15]
[norm(D1-D14),norm(D1-D15)]