function [X, Y, m] = MGS(X, Y)
% output: [X X; Y -Y]'*[0 I; I 0]*[X X; Y -Y] = [I 0; 0 -I]

[n, m] = size(Y);

i = 0;
while i < m,
    i = i + 1;
    L = norm([X(:, i), Y(:, i)], 2);
    if L == 0,
%        fprintf('(0) rank deficient at column %d\n',i);
        X(:, i) = [];
        Y(:, i) = [];
        m = m - 1;
        i = i - 1;
        continue;
    end
    X(:, i) = X(:, i) / L;
    Y(:, i) = Y(:, i) / L;
%    fprintf('step %d\n', i)
    L = X(:, i)'*Y(:, i);
    if L == 0,
%        fprintf('(1) rank deficient at column %d\n',i);
          if norm(X(:, i)==0)
                X(:, i) = Y(:, i);
          else
                Y(:, i) = X(:, i);
          end
        L = X(:, i)'*Y(:, i);
    end
    if L < 0,
        Y(:, i) = -Y(:, i);
        L = -L;
    end
    L = sqrt(2*L);

    for j = 1 : i - 1,
        R = X(:, i)'*Y(:, j) + Y(:, i)'*X(:, j);
        X(:, i) = X(:, i) - R*X(:, j);
        Y(:, i) = Y(:, i) - R*Y(:, j);
        R = X(:, j)'*Y(:, i) - Y(:, j)'*X(:, i);
        X(:, i) = X(:, i) + R*X(:, j);
        Y(:, i) = Y(:, i) - R*Y(:, j);
    end
    R = X(:, i)'*Y(:, i);
    if R < 0,
        Y(:, i) = -Y(:, i);
        R = -R;
    end
    R = sqrt(2*R);
    if abs(R) < 1e-12*L,
%        fprintf('(2) rank deficient at column %d\n',i);
        X(:, i) = [];
        Y(:, i) = [];
        m = m - 1;
        i = i - 1;
        continue;
        error('aaa')
    end
    X(:, i) = X(:, i) / R;
    Y(:, i) = Y(:, i) / R;

    while R < 0.7*L,
%        L = R;
        for j = 1 : i - 1,
            R = X(:, i)'*Y(:, j) + Y(:, i)'*X(:, j);
            X(:, i) = X(:, i) - R*X(:, j);
            Y(:, i) = Y(:, i) - R*Y(:, j);
            R = X(:, j)'*Y(:, i) - Y(:, j)'*X(:, i);
            X(:, i) = X(:, i) + R*X(:, j);
            Y(:, i) = Y(:, i) - R*Y(:, j);
        end
        R = X(:, i)'*Y(:, i);
        if R < 0,
            Y(:, i) = -Y(:, i);
            R = -R;
        end
        R = sqrt(2*R);
        if abs(R) < 1e-12*L,
%            fprintf('(3) rank deficient at column %d\n',i);
            X(:, i) = [];
            Y(:, i) = [];
            m = m - 1;
            i = i - 1;
            continue;
            error('R2=0');
        end
        X(:, i) = X(:, i) / R;
        Y(:, i) = Y(:, i) / R;
    end
%    X(:, 1:i)'*Y(:, 1:i)+Y(:, 1:i)'*X(:, 1:i)
%    X(:, 1:i)'*Y(:, 1:i)-Y(:, 1:i)'*X(:, 1:i)
end
%X'*Y+Y'*X
%X'*Y-Y'*X
%fprintf('MGS: %e, %e\n', norm(X'*Y+Y'*X-eye(m)), norm(X'*Y-Y'*X));

return
