%% QUADRATIC
% CG PRECONDITIONER
format longe
clear

n=200;
l_pos=1;l_neg=1; % number of wanted eigenpairs
k_pos=3;k_neg=3; % number of extracted eigenpairs (k_\pm >= l_\pm)
tol=1e-7;maxiter=200;
alpha = (n+1)^1;
%%
M=speye(n);
e = ones(n,1);
K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
K=sparse(K);
D=2*K;
%K = spdiags([-5*e 15*e -5*e], -1:1, n, n); D = spdiags([-10*e 30*e -10*e], -1:1, n, n); % definiteness interval is around ( -9.4818, -0.5278)
% l1inearization
A=blkdiag(alpha^2*M, -K);B=[sparse(n,n) alpha*M;alpha*M D];%2n x 2n pencil
A=A/(n+1)^2; B=B/(n+1)^2;
% definiteness interval is around ( -19.225842, -0.513351)
%% initial guess
I=speye(2*n);
II=speye(n);

% exact eigenvalues
for j = 1:n,
    t = j*pi/(n+1);
    u(2*j-1:2*j) = roots([1, 4*(n+1)^2*(1-cos(t)),2*(n+1)^2*(1-cos(t))]);
end
u = sort(u');

%% 1. TEST: mu1p and mu1n: CG based preconditioner
mu1p=-0.514;
mu1n=-19.22;
T1p=A-mu1p*B;
T1n=A-mu1n*B;

Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
msch=3;opts=2;
fprintf('\n Test1: Indefinite %d-scheme  (two preconditioners) with T_+=inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',msch,mu1p,mu1n);
tic
[D1, X, iter1,h1] = indef_m_scheme(A, B, T1p, T1n, Xini, k_pos, k_neg, tol, maxiter, msch,opts);
disp([D1, abs(D1-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t1=toc;
err1=norm(A*X-B*X*diag(D1));

%% exact preconditioner
mu1p=-0.514;
mu1n=-19.22;
T1p=A-mu1p*B;
T1n=A-mu1n*B;

Xini=full([[D(:,1:k_neg)/alpha;-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
msch=3;
fprintf('\n Test1: Indefinite %d-scheme  (two preconditioners) with T_+=inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',msch,mu1p,mu1n);
tic
[D1, X, iter1,h1] = indef_m_scheme(A, B, T1p, T1n, Xini, k_pos, k_neg, tol, maxiter, msch);
disp([D1, abs(D1-u(n+(-k_neg+1:k_pos)))./abs(u(n+(-k_neg+1:k_pos)))]);
t1=toc;
err1=norm(A*X-B*X*diag(D1));
