 %% SPRING n=2000
% EXACT PRECONDITIONER

clear

n=2000;
l_pos=3;l_neg=3; % number of wanted eigenpairs
k_pos=3;k_neg=3; % number of extracted eigenpairs (k_\pm >= l_\pm)
tol=1e-7;maxiter=1500;
M=speye(n);
e = ones(n,1);
% K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
% K=sparse(K);
% D=2*K;
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
D = spdiags([-10*e 30*e -10*e], -1:1, n, n); % definiteness interval is around ( -9.4818, -0.5278)
% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M D];%2n x 2n pencil

%% initial guess
I=speye(2*n);
II=speye(n);
%% 1. TEST: mu1p and mu1n
mu1p=-0.528;
mu1n=-9.47;
T1p=A-mu1p*B;
T1n=A-mu1n*B;

Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
msch=2;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu1p,mu1n);
tic
[D2, X, iter2,h2] =indef_m_scheme_brzo(A,B,T1p,T1n,Xini,k_pos,k_neg,tol,maxiter,msch);
t2=toc;
err2=norm(A*X-B*X*diag(D2));

msch=3;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu1p,mu1n);
tic
[D3, X, iter3,h3] =indef_m_scheme_brzo(A,B,T1p,T1n,Xini,k_pos,k_neg,tol,maxiter,msch);
t3=toc;
err3=norm(A*X-B*X*diag(D3));

msch=4;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu1p,mu1n);
tic
[D4, X, iter4,h4] =indef_m_scheme_brzo(A,B,T1p,T1n,Xini,k_pos,k_neg,tol,maxiter,msch);
t4=toc;
err4=norm(A*X-B*X*diag(D4));

msch=5;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu1p,mu1n);
tic
[D5, X, iter5,h5] =indef_m_scheme_brzo(A,B,T1p,T1n,Xini,k_pos,k_neg,tol,maxiter,msch);
t5=toc;
err5=norm(A*X-B*X*diag(D5));

msch=6;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu1p,mu1n);
tic
[D6, X, iter6,h6] =indef_m_scheme_brzo(A,B,T1p,T1n,Xini,k_pos,k_neg,tol,maxiter,msch);
t6=toc;
err6=norm(A*X-B*X*diag(D6));

msch=10;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu1p,mu1n);
tic
[D10, X, iter10,h10] =indef_m_scheme_brzo(A,B,T1p,T1n,Xini,k_pos,k_neg,tol,maxiter,msch);
t10=toc;
err10=norm(A*X-B*X*diag(D10));

msch='whole';
fprintf('\n Test1: Indefinite w.h.-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',mu1p,mu1n);
tic
[Dw, X, iterw,hw] =indef_m_scheme_brzo(A,B,T1p,T1n,Xini,k_pos,k_neg,tol,maxiter,msch);
tw=toc;
errw=norm(A*X-B*X*diag(Dw));

%%
[iter2,iter3,iter4,iter5,iter6,iter10,iterw]
m=2
[h2.step_neg,h2.step_pos]
m=3
[h3.step_neg,h3.step_pos]
m=4
[h4.step_neg,h4.step_pos]
m=5
[h5.step_neg,h5.step_pos]
m=6
[h6.step_neg,h6.step_pos]
m=10
[h10.step_neg,h10.step_pos]
m=1000
[hw.step_neg,hw.step_pos]
[err2,err3,err4,err5,err6,err10,errw]
[t2,t3,t4,t5,t6,t10,tw]

%% 2. TEST: mu2p and mu2n
mu2p=-0.5279;
mu2n=-9.47;
T2p=A-mu2p*B;
T2n=A-mu2n*B;

Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
msch=2;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu2p,mu2n);
tic
[D2, X, iter2,h2] =indef_m_scheme_brzo(A,B,T2p,T2n,Xini,k_pos,k_neg,tol,maxiter,msch);
t2=toc;
err2=norm(A*X-B*X*diag(D2));

msch=3;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu2p,mu2n);
tic
[D3, X, iter3,h3] =indef_m_scheme_brzo(A,B,T2p,T2n,Xini,k_pos,k_neg,tol,maxiter,msch);
t3=toc;
err3=norm(A*X-B*X*diag(D3));

msch=4;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu2p,mu2n);
tic
[D4, X, iter4,h4] =indef_m_scheme_brzo(A,B,T2p,T2n,Xini,k_pos,k_neg,tol,maxiter,msch);
t4=toc;
err4=norm(A*X-B*X*diag(D4));

msch=5;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu2p,mu2n);
tic
[D5, X, iter5,h5] =indef_m_scheme_brzo(A,B,T2p,T2n,Xini,k_pos,k_neg,tol,maxiter,msch);
t5=toc;
err5=norm(A*X-B*X*diag(D5));

msch=6;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu2p,mu2n);
tic
[D6, X, iter6,h6] =indef_m_scheme_brzo(A,B,T2p,T2n,Xini,k_pos,k_neg,tol,maxiter,msch);
t6=toc;
err6=norm(A*X-B*X*diag(D6));

msch=10;
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu2p,mu2n);
tic
[D10, X, iter10,h10] =indef_m_scheme_brzo(A,B,T2p,T2n,Xini,k_pos,k_neg,tol,maxiter,msch);
t10=toc;
err10=norm(A*X-B*X*diag(D10));

msch='whole';
fprintf('\n Test1: Indefinite (%d)-scheme (two preconditioners) with T_+ =inv(A-%f*B), T_-=inv(A-%f*B).\n',msch,mu2p,mu2n);
tic
[Dw, X, iterw,hw] =indef_m_scheme_brzo(A,B,T2p,T2n,Xini,k_pos,k_neg,tol,maxiter,msch);
tw=toc;
errw=norm(A*X-B*X*diag(Dw));

%%
[iter2,iter3,iter4,iter5,iter6,iter10,iterw]
m=2
[h2.step_neg,h2.step_pos]
m=3
[h3.step_neg,h3.step_pos]
m=4
[h4.step_neg,h4.step_pos]
m=5
[h5.step_neg,h5.step_pos]
m=6
[h6.step_neg,h6.step_pos]
m=10
[h10.step_neg,h10.step_pos]
m=1000
[hw.step_neg,hw.step_pos]
[err2,err3,err4,err5,err6,err10,errw]
[t2,t3,t4,t5,t6,t10,tw]
