 %%  test_spring n=1000
% EXACT INVERSE
clear

n=1000; n_pos=3;n_neg=3;nev=n_pos+n_neg;
tol=1e-8;maxiter=2000;

M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278) 
%% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M C];%2n x 2n pencil
beta1=-9;
beta6=-9.4;
beta2=-7.5;
beta3=-5;
beta4=-2.5;
beta5=-0.55;
beta7=-0.53;
T1=A-beta1*B;
T2=A-beta2*B;
T3=A-beta3*B;
T4=A-beta4*B;
T5=A-beta5*B;
T6=A-beta6*B;
T7=A-beta7*B;
I=speye(2*n);
II=speye(n);
%% output1
%Xini=[I(:,n+1:n+n_neg) I(:,1:n_pos)];
%Xini3=[I(:,n+1:(n+n_neg+3)) I(:,1:(n_pos+3))];
%Xini6=[I(:,n+1:(n+n_neg+6)) I(:,1:(n_pos+6))];
%% output2
% Xini=full([[M,II;-II,II]*I(:,n+1:n+n_neg) I(:,1:n_pos)]);
% Xini3=full([[M,II;-II,II]*I(:,n+1:(n+n_neg+3)) I(:,1:(n_pos+3))]);
%Xini6=full([[M,II;-II,II]*I(:,n+1:(n+n_neg+6)) I(:,1:(n_pos+6))]);
%% output3
Xini=full([[M,II;-II,II]*I(:,n+1:(n+n_neg)) I(:,n+1:(n+n_pos))]);
Xini3=full([[M,II;-II,II]*I(:,n+1:(n+n_neg+3)) I(:,n+1:(n+n_pos+3))]);
% Xini6=full([[M,II;-II,II]*I(:,n+1:(n+n_neg+6)) I(:,n+1:(n+n_pos+6))]);

%% beta3=-5 first testing
fprintf('Test1...\n');

tic
[D1, X, iter1,h] = indef_lobpcg(A, B, T3, [], Xini, n_pos, n_neg, tol, maxiter);
t1=toc;
evneg1=h.eigen_neg;
evpos1=h.eigen_pos;
resneg1=h.res_neg;
respos1=h.res_pos;
stepneg1=h.step_neg;
steppos1=h.step_pos;
save('output4a/outputSpring1000.mat','evneg1');
save('output4a/outputSpring1000.mat','evpos1','-append');
save('output4a/outputSpring1000.mat','resneg1','-append');
save('output4a/outputSpring1000.mat','respos1','-append');
save('output4a/outputSpring1000.mat','stepneg1','-append');
save('output4a/outputSpring1000.mat','steppos1','-append');
save('output4a/outputSpring1000.mat','D1','-append');
save('output4a/outputSpring1000.mat','iter1','-append');
save('output4a/outputSpring1000.mat','t1','-append');

fprintf('Test13...\n');
tic
[D13, X, iter13,h] = indef_lobpcg(A, B, T3, [], Xini3, n_pos, n_neg, tol, maxiter);
t13=toc;
evneg13=h.eigen_neg;
evpos13=h.eigen_pos;
resneg13=h.res_neg;
respos13=h.res_pos;
stepneg13=h.step_neg;
steppos13=h.step_pos;
save('output4a/outputSpring1000.mat','evneg13','-append');
save('output4a/outputSpring1000.mat','evpos13','-append');
save('output4a/outputSpring1000.mat','resneg13','-append');
save('output4a/outputSpring1000.mat','respos13','-append');
save('output4a/outputSpring1000.mat','stepneg13','-append');
save('output4a/outputSpring1000.mat','steppos13','-append');
save('output4a/outputSpring1000.mat','D13','-append');
save('output4a/outputSpring1000.mat','iter13','-append');
save('output4a/outputSpring1000.mat','t13','-append');

%% beta2=-7.5 and beta4=-2.5 second testing
fprintf('Test2...\n');
tic
[D2, X, iter2,h] = indef_lobpcg(A, B, T4, T2, Xini, n_pos, n_neg, tol, maxiter);
t2=toc;
evneg2=h.eigen_neg;
evpos2=h.eigen_pos;
resneg2=h.res_neg;
respos2=h.res_pos;
stepneg2=h.step_neg;
steppos2=h.step_pos;
save('output4a/outputSpring1000.mat','evneg2','-append');
save('output4a/outputSpring1000.mat','evpos2','-append');
save('output4a/outputSpring1000.mat','resneg2','-append');
save('output4a/outputSpring1000.mat','respos2','-append');
save('output4a/outputSpring1000.mat','stepneg2','-append');
save('output4a/outputSpring1000.mat','steppos2','-append');
save('output4a/outputSpring1000.mat','D2','-append');
save('output4a/outputSpring1000.mat','iter2','-append');
save('output4a/outputSpring1000.mat','t2','-append');

fprintf('Test23...\n');
tic
[D23, X, iter23,h] = indef_lobpcg(A, B, T4, T2, Xini3, n_pos, n_neg, tol, maxiter);
t23=toc;
evneg23=h.eigen_neg;
evpos23=h.eigen_pos;
resneg23=h.res_neg;
respos23=h.res_pos;
stepneg23=h.step_neg;
steppos23=h.step_pos;
save('output4a/outputSpring1000.mat','evneg23','-append');
save('output4a/outputSpring1000.mat','evpos23','-append');
save('output4a/outputSpring1000.mat','resneg23','-append');
save('output4a/outputSpring1000.mat','respos23','-append');
save('output4a/outputSpring1000.mat','stepneg23','-append');
save('output4a/outputSpring1000.mat','steppos23','-append');
save('output4a/outputSpring1000.mat','D23','-append');
save('output4a/outputSpring1000.mat','iter23','-append');
save('output4a/outputSpring1000.mat','t23','-append');

%% beta1=-9 and beta5=-0.55 third testing

fprintf('Test3...\n');
tic
[D3, X, iter3,h] = indef_lobpcg(A, B, T5, T1, Xini, n_pos, n_neg, tol, maxiter);
t3=toc;
evneg3=h.eigen_neg;
evpos3=h.eigen_pos;
resneg3=h.res_neg;
respos3=h.res_pos;
stepneg3=h.step_neg;
steppos3=h.step_pos;
save('output4a/outputSpring1000.mat','evneg3','-append');
save('output4a/outputSpring1000.mat','evpos3','-append');
save('output4a/outputSpring1000.mat','resneg3','-append');
save('output4a/outputSpring1000.mat','respos3','-append');
save('output4a/outputSpring1000.mat','stepneg3','-append');
save('output4a/outputSpring1000.mat','steppos3','-append');
save('output4a/outputSpring1000.mat','D3','-append');
save('output4a/outputSpring1000.mat','iter3','-append');
save('output4a/outputSpring1000.mat','t3','-append');

fprintf('Test33...\n');
tic
[D33, X, iter33,h] = indef_lobpcg(A, B, T5, T1, Xini3, n_pos, n_neg, tol, maxiter);
t33=toc;
evneg33=h.eigen_neg;
evpos33=h.eigen_pos;
resneg33=h.res_neg;
respos33=h.res_pos;
stepneg33=h.step_neg;
steppos33=h.step_pos;
save('output4a/outputSpring1000.mat','evneg33','-append');
save('output4a/outputSpring1000.mat','evpos33','-append');
save('output4a/outputSpring1000.mat','resneg33','-append');
save('output4a/outputSpring1000.mat','respos33','-append');
save('output4a/outputSpring1000.mat','stepneg33','-append');
save('output4a/outputSpring1000.mat','steppos33','-append');
save('output4a/outputSpring1000.mat','D33','-append');
save('output4a/outputSpring1000.mat','iter33','-append');
save('output4a/outputSpring1000.mat','t33','-append');



%% beta6=-9.4 and beta7=-0.53 forth testing

fprintf('Test4...\n');
hsl_mi20_startup
control6 = hsl_mi20_control;
control6.c_fail = 2;
inform6 = hsl_mi20_setup6(T6,control6);
control7 = hsl_mi20_control;
control7.c_fail = 2;
inform7 = hsl_mi20_setup7(T7,control7);

tic
[D4, X, iter4,h] = indef_lobpcg(A, B, T7, T6, Xini, n_pos, n_neg, tol, maxiter);
t4=toc;
evneg4=h.eigen_neg;
evpos4=h.eigen_pos;
resneg4=h.res_neg;
respos4=h.res_pos;
stepneg4=h.step_neg;
steppos4=h.step_pos;
save('output4a/outputSpring1000.mat','evneg4','-append');
save('output4a/outputSpring1000.mat','evpos4','-append');
save('output4a/outputSpring1000.mat','resneg4','-append');
save('output4a/outputSpring1000.mat','respos4','-append');
save('output4a/outputSpring1000.mat','stepneg4','-append');
save('output4a/outputSpring1000.mat','steppos4','-append');
save('output4a/outputSpring1000.mat','D4','-append');
save('output4a/outputSpring1000.mat','iter4','-append');
save('output4a/outputSpring1000.mat','t4','-append');

fprintf('Test43...\n');
tic
[D43, X, iter43,h] = indef_lobpcg(A, B, T7, T6, Xini3, n_pos, n_neg, tol, maxiter);
t43=toc;
evneg43=h.eigen_neg;
evpos43=h.eigen_pos;
resneg43=h.res_neg;
respos43=h.res_pos;
stepneg43=h.step_neg;
steppos43=h.step_pos;
save('output4a/outputSpring1000.mat','evneg43','-append');
save('output4a/outputSpring1000.mat','evpos43','-append');
save('output4a/outputSpring1000.mat','resneg43','-append');
save('output4a/outputSpring1000.mat','respos43','-append');
save('output4a/outputSpring1000.mat','stepneg43','-append');
save('output4a/outputSpring1000.mat','steppos43','-append');
save('output4a/outputSpring1000.mat','D43','-append');
save('output4a/outputSpring1000.mat','iter43','-append');
save('output4a/outputSpring1000.mat','t43','-append');

%% beta1=-9 and beta7=-0.53 fifth testing

fprintf('Test5...\n');
hsl_mi20_startup
control1 = hsl_mi20_control;
control1.c_fail = 2;
inform1 = hsl_mi20_setup1(T1,control1);
control7 = hsl_mi20_control;
control7.c_fail = 2;
inform7 = hsl_mi20_setup7(T7,control7);

tic
[D5, X, iter5,h] = indef_lobpcg(A, B, T7, T1, Xini, n_pos, n_neg, tol, maxiter);
t5=toc;
evneg5=h.eigen_neg;
evpos5=h.eigen_pos;
resneg5=h.res_neg;
respos5=h.res_pos;
stepneg5=h.step_neg;
steppos5=h.step_pos;
save('output4a/outputSpring1000.mat','evneg5','-append');
save('output4a/outputSpring1000.mat','evpos5','-append');
save('output4a/outputSpring1000.mat','resneg5','-append');
save('output4a/outputSpring1000.mat','respos5','-append');
save('output4a/outputSpring1000.mat','stepneg5','-append');
save('output4a/outputSpring1000.mat','steppos5','-append');
save('output4a/outputSpring1000.mat','D5','-append');
save('output4a/outputSpring1000.mat','iter5','-append');
save('output4a/outputSpring1000.mat','t5','-append');

fprintf('Test53...\n');
tic
[D53, X, iter53,h] = indef_lobpcg(A, B,  T7, T1, Xini3, n_pos, n_neg, tol, maxiter);
t53=toc;
evneg53=h.eigen_neg;
evpos53=h.eigen_pos;
resneg53=h.res_neg;
respos53=h.res_pos;
stepneg53=h.step_neg;
steppos53=h.step_pos;
save('output4a/outputSpring1000.mat','evneg53','-append');
save('output4a/outputSpring1000.mat','evpos53','-append');
save('output4a/outputSpring1000.mat','resneg53','-append');
save('output4a/outputSpring1000.mat','respos53','-append');
save('output4a/outputSpring1000.mat','stepneg53','-append');
save('output4a/outputSpring1000.mat','steppos53','-append');
save('output4a/outputSpring1000.mat','D53','-append');
save('output4a/outputSpring1000.mat','iter53','-append');
save('output4a/outputSpring1000.mat','t53','-append');
%%

% ItTimes1000=[t1,t13,t2,t23,t3,t33,t,t4,t43];
% NIterations1000=[iter1,iter13,iter2,iter23,iter3,iter33,iter4,iter43];
% save('output4a/outputSpring1000.mat','ItTimes1000','-append');
% save('output4a/outputSpring1000.mat','NIterations1000','-append');

[stepneg1(2,3),stepneg13(2,3),stepneg2(2,3),stepneg23(2,3)]
[stepneg3(2,3),stepneg33(2,3),stepneg4(2,3),stepneg43(2,3)]
[steppos1(2,3),steppos13(2,3),steppos2(2,3),steppos23(2,3)]
[steppos3(2,3),steppos33(2,3),steppos4(2,3),steppos43(2,3)]
[t1,t13,t2,t23,t3,t33,t4,t43]