 %%  test_spring n=2000
% EXACT INVERSE
clear
n=2000;
l_pos=3;l_neg=3;nev=l_pos+l_neg;
tol=1e-8;maxiter=2000;
M=speye(n);
e = ones(n,1);
C = spdiags([-10*e 30*e -10*e], -1:1, n, n);
K = (n+1)^2*full(spdiags([-e 2*e -e], -1:1, n, n));
%K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
% definiteness interval is around ( -9.4818, -0.5278) 
%% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M C];%2n x 2n pencil
mu0=0;
mu1p=-9;
mu1n=-9.4;
mu2p=-7.5;
mu2n=-5;
T0=A-mu0*B;
T1p=A-mu1p*B;
T1n=A-mu1n*B;
T2p=A-mu2p*B;
T2n=A-mu2n*B;

%% initial guess
br_pos=3;br_neg=3;
I=speye(2*n);
II=speye(n);
%Xini=[I(:,n+1:n+l_neg) I(:,1:l_pos)];
%Xini3=[I(:,n+1:(n+l_neg+br_neg)) I(:,1:(l_pos+br_pos))];
%%
Xini=full([[M,II;-II,II]*I(:,n+1:n+l_neg) I(:,1:l_pos)]);
Xini_br=full([[M,II;-II,II]*I(:,n+1:(n+l_neg+br_neg)) I(:,1:(l_pos+br_pos))]);

%% 1. TEST:  mu0 
fprintf('Test1: Algorithm 1 (one preconditioner) with T=inv(A-%f*B) and Xini \n',mu0);
tic
[D1, X, iter1,h] = indef_lobpcg(A, B, T0, [], Xini, l_pos, l_neg, tol, maxiter);
t1=toc;

fprintf('Test1: Algorithm 1 (one preconditioner) with T=inv(A-%f*B) and Xini_br \n',mu0);
tic
[D1_br, X, iter1_br,h_br] = indef_lobpcg(A, B, T0, [], Xini_br, l_pos, l_neg, tol, maxiter);
t1_br=toc;


%% 2. TEST: mu1p and mu1n
fprintf('Test2: Algorithm 2 (two preconditioners) with T_+=inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',mu1p,mu1n);
tic
[D2, X, iter2,h] = indef_lobpcg(A, B, T1p, T1n, Xini, l_pos, l_neg, tol, maxiter);
t2=toc;
fprintf('Test2: Algorithm 2 (two preconditioners) with T_+=inv(A-%f*B), T_-=inv(A-%f*B) and Xini_br \n',mu1p,mu1n);
tic
[D23, X, iter23,h] = indef_lobpcg(A, B, T1p, T1n, Xini_br, l_pos, l_neg, tol, maxiter);
t23=toc;
evneg23=h.eigen_neg;
evpos23=h.eigen_pos;
resneg23=h.res_neg;
respos23=h.res_pos;
stepneg23=h.step_neg;
steppos23=h.step_pos;
save('output4/outputSpring2000.mat','evneg23','-append');
save('output4/outputSpring2000.mat','evpos23','-append');
save('output4/outputSpring2000.mat','resneg23','-append');
save('output4/outputSpring2000.mat','respos23','-append');
save('output4/outputSpring2000.mat','stepneg23','-append');
save('output4/outputSpring2000.mat','steppos23','-append');
save('output4/outputSpring2000.mat','D23','-append');
save('output4/outputSpring2000.mat','iter23','-append');
save('output4/outputSpring2000.mat','t23','-append');

%% beta1=-9 and beta5=-0.55 third testing

fprintf('Test3...\n');
tic
[D3, X, iter3,h] = indef_lobpcg(A, B, T5, T1, Xini, n_pos, n_neg, tol, maxiter);
t3=toc;
evneg3=h.eigen_neg;
evpos3=h.eigen_pos;
resneg3=h.res_neg;
respos3=h.res_pos;
stepneg3=h.step_neg;
steppos3=h.step_pos;
save('output4/outputSpring2000.mat','evneg3','-append');
save('output4/outputSpring2000.mat','evpos3','-append');
save('output4/outputSpring2000.mat','resneg3','-append');
save('output4/outputSpring2000.mat','respos3','-append');
save('output4/outputSpring2000.mat','stepneg3','-append');
save('output4/outputSpring2000.mat','steppos3','-append');
save('output4/outputSpring2000.mat','D3','-append');
save('output4/outputSpring2000.mat','iter3','-append');
save('output4/outputSpring2000.mat','t3','-append');

fprintf('Test33...\n');
tic
[D33, X, iter33,h] = indef_lobpcg(A, B, T5, T1, Xini3, n_pos, n_neg, tol, maxiter);
t33=toc;
evneg33=h.eigen_neg;
evpos33=h.eigen_pos;
resneg33=h.res_neg;
respos33=h.res_pos;
stepneg33=h.step_neg;
steppos33=h.step_pos;
save('output4/outputSpring2000.mat','evneg33','-append');
save('output4/outputSpring2000.mat','evpos33','-append');
save('output4/outputSpring2000.mat','resneg33','-append');
save('output4/outputSpring2000.mat','respos33','-append');
save('output4/outputSpring2000.mat','stepneg33','-append');
save('output4/outputSpring2000.mat','steppos33','-append');
save('output4/outputSpring2000.mat','D33','-append');
save('output4/outputSpring2000.mat','iter33','-append');
save('output4/outputSpring2000.mat','t33','-append');



%% beta6=-9.4 and beta7=-0.53 forth testing

fprintf('Test4...\n');
hsl_mi20_startup
control6 = hsl_mi20_control;
control6.c_fail = 2;
inform6 = hsl_mi20_setup6(T6,control6);
control7 = hsl_mi20_control;
control7.c_fail = 2;
inform7 = hsl_mi20_setup7(T7,control7);

tic
[D4, X, iter4,h] = indef_lobpcg(A, B, T7, T6, Xini, n_pos, n_neg, tol, maxiter);
t4=toc;
evneg4=h.eigen_neg;
evpos4=h.eigen_pos;
resneg4=h.res_neg;
respos4=h.res_pos;
stepneg4=h.step_neg;
steppos4=h.step_pos;
save('output4/outputSpring2000.mat','evneg4','-append');
save('output4/outputSpring2000.mat','evpos4','-append');
save('output4/outputSpring2000.mat','resneg4','-append');
save('output4/outputSpring2000.mat','respos4','-append');
save('output4/outputSpring2000.mat','stepneg4','-append');
save('output4/outputSpring2000.mat','steppos4','-append');
save('output4/outputSpring2000.mat','D4','-append');
save('output4/outputSpring2000.mat','iter4','-append');
save('output4/outputSpring2000.mat','t4','-append');

fprintf('Test43...\n');
tic
[D43, X, iter43,h] = indef_lobpcg(A, B, T7, T6, Xini3, n_pos, n_neg, tol, maxiter);
t43=toc;
evneg43=h.eigen_neg;
evpos43=h.eigen_pos;
resneg43=h.res_neg;
respos43=h.res_pos;
stepneg43=h.step_neg;
steppos43=h.step_pos;
save('output4/outputSpring2000.mat','evneg43','-append');
save('output4/outputSpring2000.mat','evpos43','-append');
save('output4/outputSpring2000.mat','resneg43','-append');
save('output4/outputSpring2000.mat','respos43','-append');
save('output4/outputSpring2000.mat','stepneg43','-append');
save('output4/outputSpring2000.mat','steppos43','-append');
save('output4/outputSpring2000.mat','D43','-append');
save('output4/outputSpring2000.mat','iter43','-append');
save('output4/outputSpring2000.mat','t43','-append');

%% beta1=-9 and beta7=-0.53 fifth testing

fprintf('Test5...\n');
hsl_mi20_startup
control1 = hsl_mi20_control;
control1.c_fail = 2;
inform1 = hsl_mi20_setup1(T1,control1);
control7 = hsl_mi20_control;
control7.c_fail = 2;
inform7 = hsl_mi20_setup7(T7,control7);

tic
[D5, X, iter5,h] = indef_lobpcg(A, B, T7, T1, Xini, n_pos, n_neg, tol, maxiter);
t5=toc;
evneg5=h.eigen_neg;
evpos5=h.eigen_pos;
resneg5=h.res_neg;
respos5=h.res_pos;
stepneg5=h.step_neg;
steppos5=h.step_pos;
save('output4/outputSpring2000.mat','evneg5','-append');
save('output4/outputSpring2000.mat','evpos5','-append');
save('output4/outputSpring2000.mat','resneg5','-append');
save('output4/outputSpring2000.mat','respos5','-append');
save('output4/outputSpring2000.mat','stepneg5','-append');
save('output4/outputSpring2000.mat','steppos5','-append');
save('output4/outputSpring2000.mat','D5','-append');
save('output4/outputSpring2000.mat','iter5','-append');
save('output4/outputSpring2000.mat','t5','-append');

fprintf('Test53...\n');
tic
[D53, X, iter53,h] = indef_lobpcg(A, B,  T7, T1, Xini3, n_pos, n_neg, tol, maxiter);
t53=toc;
evneg53=h.eigen_neg;
evpos53=h.eigen_pos;
resneg53=h.res_neg;
respos53=h.res_pos;
stepneg53=h.step_neg;
steppos53=h.step_pos;
save('output4/outputSpring2000.mat','evneg53','-append');
save('output4/outputSpring2000.mat','evpos53','-append');
save('output4/outputSpring2000.mat','resneg53','-append');
save('output4/outputSpring2000.mat','respos53','-append');
save('output4/outputSpring2000.mat','stepneg53','-append');
save('output4/outputSpring2000.mat','steppos53','-append');
save('output4/outputSpring2000.mat','D53','-append');
save('output4/outputSpring2000.mat','iter53','-append');
save('output4/outputSpring2000.mat','t53','-append');

[stepneg1(2,3),stepneg13(2,3),stepneg2(2,3),stepneg23(2,3)]
[stepneg3(2,3),stepneg33(2,3),stepneg4(2,3),stepneg43(2,3)]
[steppos1(2,3),steppos13(2,3),steppos2(2,3),steppos23(2,3)]
[steppos3(2,3),steppos33(2,3),steppos4(2,3),steppos43(2,3)]
[t1,t13,t2,t23,t3,t33,t4,t43]
